## wlcs 1.1.0+dfsg

=== CMakeLists.txt ===
# Copyright © 2017 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 or 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Thomas Voss <thomas.voss@canonical.com>,
#              Alan Griffiths <alan@octopull.co.uk>,
#              Christopher James Halse Rogers <christopher.halse.rogers@canonical.com>

cmake_minimum_required(VERSION 3.5)

cmake_policy(SET CMP0015 NEW)
cmake_policy(SET CMP0022 NEW)

project(wlcs VERSION 1.0.0)

add_definitions(-D_GNU_SOURCE)
add_definitions(-D_FILE_OFFSET_BITS=64)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
include(GNUInstallDirs)
find_package(PkgConfig)
#include (Doxygen.cmake)


set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pthread -g -Werror -Wall -pedantic -Wextra -fPIC")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread -g -std=c++14 -Werror -Wall -fno-strict-aliasing -pedantic -Wnon-virtual-dtor -Wextra -fPIC")
if ("${CMAKE_SHARED_LINKER_FLAGS}" MATCHES ".*-fsanitize=.*")
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS}")
else()
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--as-needed -Wl,--no-undefined")
endif()

include(CheckCXXCompilerFlag)
check_cxx_compiler_flag(-Wgnu-zero-variadic-macro-arguments HAVE_W_GNU_VARIADIC_MACROS)
if (HAVE_W_GNU_VARIADIC_MACROS)
  # GTest's parametrised test macro tweaks this warning
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=gnu-zero-variadic-macro-arguments")
endif ()

find_package(Boost)
find_package(GtestGmock)
pkg_check_modules(WAYLAND_CLIENT REQUIRED wayland-client)
pkg_check_modules(WAYLAND_SERVER REQUIRED wayland-server)
pkg_check_modules(WAYLAND_SCANNER REQUIRED wayland-scanner)

include_directories(include)
include_directories(${Boost_INCLUDE_DIRS})
include_directories(${GMOCK_INCLUDE_DIR} ${GTEST_INCLUDE_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})

set(PROTOCOL_SOURCES "")

execute_process(
  COMMAND wayland-scanner --version
  OUTPUT_VARIABLE WAYLAND_SCANNER_VERSION_OUTPUT
  ERROR_VARIABLE WAYLAND_SCANNER_VERSION_OUTPUT
)

separate_arguments(WAYLAND_SCANNER_VERSION_OUTPUT)
list(LENGTH WAYLAND_SCANNER_VERSION_OUTPUT VERSION_STRING_COMPONENTS)
list(GET WAYLAND_SCANNER_VERSION_OUTPUT 1 VERSION_STRING)
string(STRIP ${VERSION_STRING} VERSION_STRING)

if (NOT(VERSION_STRING_COMPONENTS EQUAL 2))
  message(AUTHOR_WARNING "Failed to parse wayland-scanner --version output")
endif()

if (VERSION_STRING VERSION_GREATER 1.14.91)
  message(STATUS "Found wayland-scanner version ${VERSION_STRING}, using private-code mode")
  set(WAYLAND_SCANNER_CODE_GENERATION_TYPE "private-code")
else()
  message(STATUS "Found wayland-scanner version ${VERSION_STRING}, using (old) code mode")
  set(WAYLAND_SCANNER_CODE_GENERATION_TYPE "code")
endif()

file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/generated)

macro(GENERATE_PROTOCOL PROTOCOL_NAME)
  set(PROTOCOL_PATH "${CMAKE_CURRENT_SOURCE_DIR}/src/protocol/${PROTOCOL_NAME}.xml")
  set(OUTPUT_PATH_C "${CMAKE_CURRENT_BINARY_DIR}/generated/${PROTOCOL_NAME}.c")
  set(OUTPUT_PATH_SERVER_H "${CMAKE_CURRENT_BINARY_DIR}/generated/${PROTOCOL_NAME}-server.h")
  set(OUTPUT_PATH_CLIENT_H "${CMAKE_CURRENT_BINARY_DIR}/generated/${PROTOCOL_NAME}-client.h")
  add_custom_command(OUTPUT "${OUTPUT_PATH_C}"
    VERBATIM
    COMMAND "wayland-scanner" "--include-core-only" ${WAYLAND_SCANNER_CODE_GENERATION_TYPE} "${PROTOCOL_PATH}" "${OUTPUT_PATH_C}"
    DEPENDS "${PROTOCOL_PATH}"
  )
  add_custom_command(OUTPUT "${OUTPUT_PATH_SERVER_H}"
    VERBATIM
    COMMAND "wayland-scanner" "--include-core-only" "server-header" "${PROTOCOL_PATH}" "${OUTPUT_PATH_SERVER_H}"
    DEPENDS "${PROTOCOL_PATH}"
  )
  add_custom_command(OUTPUT "${OUTPUT_PATH_CLIENT_H}"
    VERBATIM
    COMMAND "wayland-scanner" "--include-core-only" "client-header" "${PROTOCOL_PATH}" "${OUTPUT_PATH_CLIENT_H}"
    DEPENDS "${PROTOCOL_PATH}"
  )
  list(APPEND PROTOCOL_SOURCES ${OUTPUT_PATH_C} ${OUTPUT_PATH_CLIENT_H})
endmacro()

GENERATE_PROTOCOL(gtk-primary-selection)
GENERATE_PROTOCOL(primary-selection-unstable-v1)
GENERATE_PROTOCOL(wayland)
GENERATE_PROTOCOL(xdg-shell-unstable-v6)
GENERATE_PROTOCOL(xdg-shell)

option(WLCS_BUILD_ASAN "Build a test runner with AddressSanitizer annotations" ON)
option(WLCS_BUILD_TSAN "Build a test runner with ThreadSanitizer annotations" ON)
option(WLCS_BUILD_UBSAN "Build a test runner with UndefinedBehaviourSanitizer annotations" ON)

set(
  WLCS_SOURCES

  include/wlcs/display_server.h
  include/wlcs/pointer.h
  include/wlcs/touch.h
  include/helpers.h
  include/in_process_server.h
  include/primary_selection.h
  include/xdg_shell_v6.h
  include/xdg_shell_stable.h

  src/data_device.cpp
  src/gtk_primary_selection.cpp
  src/helpers.cpp
  src/in_process_server.cpp
  src/xdg_shell_v6.cpp
  src/xdg_shell_stable.cpp
  src/main.cpp
  src/primary_selection.cpp
  src/shared_library.cpp
  src/xfail_supporting_test_listener.h
  src/xfail_supporting_test_listener.cpp
  src/termcolor.hpp
  src/thread_proxy.h

  ${PROTOCOL_SOURCES}

  tests/test_bad_buffer.cpp
  tests/copy_cut_paste.cpp
  tests/gtk_primary_selection.cpp
  tests/test_surface_events.cpp
  tests/touches.cpp
  tests/wl_output.cpp
  tests/surface_input_regions.cpp
  tests/frame_submission.cpp
  tests/primary_selection.cpp
  tests/subsurfaces.cpp
  tests/xdg_surface_v6.cpp
  tests/xdg_toplevel_v6.cpp
  tests/xdg_surface_stable.cpp
  tests/xdg_toplevel_stable.cpp
  tests/xdg_popup.cpp
  tests/self_test.cpp
)

add_library(test_c_compile OBJECT src/test_c_compile.c)

add_executable(wlcs ${WLCS_SOURCES})
set(EXECUTABLE_TARGETS wlcs)
if (WLCS_BUILD_ASAN)
  add_executable(wlcs.asan ${WLCS_SOURCES})
  target_compile_options(wlcs.asan PUBLIC -fsanitize=address -fno-omit-frame-pointer)
  set_target_properties(
    wlcs.asan
    PROPERTIES
    LINK_FLAGS -fsanitize=address)

  # Explicitly linking with the sanitiser is harmless
  target_link_libraries(wlcs.asan asan)
  list(APPEND EXECUTABLE_TARGETS wlcs.asan)
endif()

if (WLCS_BUILD_TSAN)
  add_executable(wlcs.tsan ${WLCS_SOURCES})
  target_compile_options(wlcs.tsan PUBLIC -fsanitize=thread -fno-omit-frame-pointer)
  set_target_properties(
    wlcs.tsan
    PROPERTIES
    LINK_FLAGS -fsanitize=thread)
  # Explicitly linking with the sanitiser is harmless.
  target_link_libraries(wlcs.tsan tsan)
  list(APPEND EXECUTABLE_TARGETS wlcs.tsan)
endif()

if (WLCS_BUILD_UBSAN)
  add_executable(wlcs.ubsan ${WLCS_SOURCES})
  target_compile_options(wlcs.ubsan PUBLIC -fsanitize=undefined)
  set_target_properties(
    wlcs.ubsan
    PROPERTIES
    LINK_FLAGS -fsanitize=undefined)

  # Unsure quite why explicitly linking with ubsan is required, but here we are…
  target_link_libraries(wlcs.ubsan ubsan)
  list(APPEND EXECUTABLE_TARGETS wlcs.ubsan)
endif()

foreach(TARGET IN LISTS EXECUTABLE_TARGETS)
  target_link_libraries(
    ${TARGET}

    ${WAYLAND_CLIENT_LDFLAGS} ${WAYLAND_CLIENT_LIBRARIES}
    ${WAYLAND_SERVER_LDFLAGS} ${WAYLAND_CLIENT_LIBRARIES}
    dl

    ${GMOCK_LIBRARY}
    ${GTEST_LIBRARY}
  )
endforeach(TARGET)

install(
  TARGETS ${EXECUTABLE_TARGETS}
  RUNTIME DESTINATION ${CMAKE_INSTALL_LIBEXECDIR}/wlcs
)

install(
  DIRECTORY include/wlcs
  DESTINATION ${CMAKE_INSTALL_PREFIX}/include/
)

configure_file(
  wlcs.pc.in
  ${CMAKE_CURRENT_BINARY_DIR}/wlcs.pc
  @ONLY
)

install(
  FILES
    ${CMAKE_CURRENT_BINARY_DIR}/wlcs.pc
  DESTINATION
    ${CMAKE_INSTALL_LIBDIR}/pkgconfig/
)

## wlcs 1.1.0

=== debian/changelog ===
wlcs (1.1.0-0ubuntu3) eoan; urgency=medium

  * debian/rules:
    + Drop TSan and ASan builds from s390x; s390x doesn't have TSan, and the
      ASan build fails to link.

 -- Christopher James Halse Rogers <raof@ubuntu.com>  Tue, 24 Sep 2019 11:10:39 +1000

wlcs (1.1.0-0ubuntu2) eoan; urgency=medium

  * debian/rules:
  * debian/patches/fix-pkg-config-with-absolute-libexec-configured.patch:
    + Drop, instead passing a relative CMAKE_INSTALL_LIBEXECDIR
  * debian/copyright:
    + Fix the paths of tests/xdg_*.cpp

 -- Christopher James Halse Rogers <raof@ubuntu.com>  Mon, 26 Aug 2019 10:17:06 +1000

wlcs (1.1.0-0ubuntu1) eoan; urgency=medium

  * Initial upload to Ubuntu
  * debian/patches/fix-cmake-version.patch:
    + Cherry pick fix for project version. This is 1.1.0, not 1.0.0!
  * debian/patches/fix-pkg-config-with-absolute-libexec-configured.patch:
    + Fix duplicate ${prefix} in wlcs.pc when manually specifying
      CMAKE_INSTALL_LIBEXECDIR

 -- Christopher James Halse Rogers <raof@ubuntu.com>  Wed, 21 Aug 2019 12:08:38 +1000

=== debian/control ===
Source: wlcs
Priority: optional
Maintainer: Christopher James Halse Rogers <raof@ubuntu.com>
Build-Depends:
 debhelper-compat (= 12),
 cmake,
 libboost-dev,
 libgtest-dev,
 libwayland-dev,
 pkg-config,
 google-mock
Standards-Version: 4.4.0
Section: devel
Homepage: https://github.com/MirServer/wlcs
Vcs-Browser: https://salsa.debian.org/mir-server-team/wlcs
Vcs-Git: https://salsa.debian.org/mir-server-team/wlcs.git -b archive-ubuntu

Package: wlcs
Section: devel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Wayland Conformance Suite's
 wlcs aspires to be a protocol-conformance-verifying test suite usable by
 Wayland compositor implementations.
 .
 This package contains the headers necessary for a Wayland compositor to
 provide the integration module needed to run wlcs tests, and the test
 runner binary needed to run the tests against the compositor.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

COMMON_CONFIGURE_OPTIONS =\
  -DWLCS_BUILD_ASAN=ON \
  -DWLCS_BUILD_UBSAN=ON \
  -DWLCS_BUILD_TSAN=ON \
  -DCMAKE_INSTALL_LIBEXECDIR="lib/${DEB_HOST_MULTIARCH}"

ifeq ($(filter i386 armhf s390x, $(DEB_HOST_ARCH)),)
  ifeq ($(DEB_DISTRIBUTION),xenial)
    ifneq ($(filter arm64 ppc64el, $(DEB_HOST_ARCH)),)
      # arm64 on 16.04 does not have tsan
      COMMON_CONFIGURE_OPTIONS += -DWLCS_BUILD_TSAN=OFF
    endif
  endif
else
  # i386, armhf, and s390x do not have tsan
  COMMON_CONFIGURE_OPTIONS += -DWLCS_BUILD_TSAN=OFF
endif

ifneq ($(filter s390x, $(DEB_HOST_ARCH)),)
  # asan fails to link on s390x
  COMMON_CONFIGURE_OPTIONS += -DWLCS_BUILD_ASAN=OFF
endif

override_dh_auto_configure:
	dh_auto_configure -- $(COMMON_CONFIGURE_OPTIONS)

%:
	dh $@

## wlcs 1.1.0%2Bdfsg

=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4

opts="pgpsigurlmangle=s/$/.asc/,dversionmangle=s/\+dfsg//,repacksuffix=+dfsg" \
    https://github.com/MirServer/wlcs/releases/latest .*/wlcs-(\d\S+)\.tar\.xz

## wlcs 1.1.0+dfsg

=== debian/changelog ===
wlcs (1.1.0+dfsg-5ubuntu1) groovy; urgency=medium

  * Merge with Debian; remaining changes:
    - Disable asan on riscv64 and s390x to fix FTBFS.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 24 Jul 2020 16:34:28 +0200

wlcs (1.1.0+dfsg-5) unstable; urgency=medium

  * debian/control:
    + Fix plural form of suite in SYNOPSIS. (Closes: #962015).
  * debian/rules:
    + Set WLCS_BUILD_ASAN to OFF on mipsel and mips64el architectures.

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 14 Jul 2020 00:45:24 +0200

wlcs (1.1.0+dfsg-4ubuntu2) focal; urgency=medium

  * Disable asan on riscv64 to fix FTBFS.

 -- William Grant <wgrant@ubuntu.com>  Fri, 10 Apr 2020 14:56:04 +1000

wlcs (1.1.0+dfsg-4ubuntu1) focal; urgency=medium

  * Restore/adapt ~raof's change to disable ASan on s390x to fix FTBFS.

 -- Logan Rosen <logan@ubuntu.com>  Sat, 14 Mar 2020 22:29:46 -0400

wlcs (1.1.0+dfsg-4) unstable; urgency=medium

  * debian/rules:
    + Drop old comments.
    + Fix varialble name WITH_UBSAN.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 17 Feb 2020 22:53:56 +0100

wlcs (1.1.0+dfsg-3) unstable; urgency=medium

  * debian/control:
    + Limit building to linux-any architectures.
  * debian/rules:
    + Disable UBSAN and TSAN sanitizers on architectures that don't support
      them.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 17 Feb 2020 20:47:38 +0100

wlcs (1.1.0+dfsg-2) unstable; urgency=medium

  * Source-only upload as-is.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 02 Feb 2020 07:37:17 +0100

wlcs (1.1.0+dfsg-1) unstable; urgency=medium

  [ Christopher James Halse Rogers ]
  * Prepare initial version wlcs src:pkg for Ubuntu.

  [ Mike Gabriel ]
  * Repack upstream version 1.1.0 -> 1.1.0+dfsg. The upstream
    sources contain an encrypted file.
  * debian/control:
    + Update Maintainer: and Uploaders: fields.
    + Add Rules-Requires-Root: field and set it to 'no'.
    + Cosmetic update of D field, list deps line-by-line.
    + In Vcs-Git: field, drop branch attribute (we are on master branch now).
    + Bump Standards-Version: to 4.4.1. No changes needed.
    + In src:pkg definitions, move Section: field further up.
    + Drop Section: field from bin:pkg wlcs.
  * debian/copyright:
    + Re-work entirely. Lists files individually for better license and
      copyright tracking.
  * debian/upstream/signing-key.asc:
    + Reduce key size, make key minimal.
  * debian/upstream/metadata:
    + Add file for being DEP-12 compliant.
  * debian/gbp.conf:
    + Update for new branch layout on salsa.
  * debian/watch:
    + Re-packing the orig tarball is required to drop encrypted file from
      upstream sources; add dversionmangle and repacksuffix options.
  * debian/rules:
    + Add get-orig-source target with cmdline options for repacking the orig
      tarball.
  * Initial upload to Debian. (Closes: #949474).

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 21 Jan 2020 14:01:19 +0100

wlcs (1.1.0-0ubuntu2) UNRELEASED; urgency=medium

  * debian/rules:
  * debian/patches/fix-pkg-config-with-absolute-libexec-configured.patch:
    + Drop, instead passing a relative CMAKE_INSTALL_LIBEXECDIR

 -- Christopher James Halse Rogers <raof@ubuntu.com>  Thu, 22 Aug 2019 16:30:49 +1000

=== debian/control ===
Source: wlcs
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Mir Team <team+mir@tracker.debian.org>
Uploaders:
 Christopher James Halse Rogers <raof@ubuntu.com>,
 Mike Gabriel <sunweaver@debian.org>,
Build-Depends:
 debhelper-compat (= 12),
 cmake,
 libboost-dev,
 libgtest-dev,
 libwayland-dev,
 pkg-config,
 google-mock
Standards-Version: 4.4.1
Rules-Requires-Root: no
Homepage: https://github.com/MirServer/wlcs
Vcs-Browser: https://salsa.debian.org/mir-server-team/wlcs
Vcs-Git: https://salsa.debian.org/mir-server-team/wlcs.git

Package: wlcs
Architecture: linux-any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Wayland Conformance Suites
 wlcs aspires to be a protocol-conformance-verifying test suite usable by
 Wayland compositor implementations.
 .
 This package contains the headers necessary for a Wayland compositor to
 provide the integration module needed to run wlcs tests, and the test
 runner binary needed to run the tests against the compositor.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

WITH_ASAN  = -DWLCS_BUILD_ASAN=ON
WITH_UBSAN = -DWLCS_BUILD_UBSAN=ON
WITH_TSAN  = -DWLCS_BUILD_TSAN=ON

ifeq ($(DEB_DISTRIBUTION),xenial)
  ifneq ($(filter arm64 ppc64el, $(DEB_HOST_ARCH)),)
    # arm64 on 16.04 does not have tsan
    WITH_TSAN = -DWLCS_BUILD_TSAN=OFF
  endif
endif

ifneq ($(filter armel armhf i386 mipsel mips64el s390x alpha hppa ia64 m68k powerpc riscv64 sh4 sparc64 x32, $(DEB_HOST_ARCH)),)
  WITH_TSAN = -DWLCS_BUILD_TSAN=OFF
endif

ifneq ($(filter mipsel mips64el alpha hppa ia64 m68k powerpc riscv64 sh4, $(DEB_HOST_ARCH)),)
  WITH_UBSAN = -DWLCS_BUILD_UBSAN=OFF
endif

ifneq ($(filter mipsel mips64el riscv64 s390x, $(DEB_HOST_ARCH)),)
  WITH_ASAN = -DWLCS_BUILD_ASAN=OFF
endif

COMMON_CONFIGURE_OPTIONS =\
  $(WITH_ASAN) \
  $(WITH_UBSAN) \
  $(WITH_TSAN) \
  -DCMAKE_INSTALL_LIBEXECDIR="lib/${DEB_HOST_MULTIARCH}"

override_dh_auto_configure:
	dh_auto_configure -- $(COMMON_CONFIGURE_OPTIONS)

%:
	dh $@

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --repack --destdir=..

## wlcs 1.2.0+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -21,7 +21,7 @@
 cmake_policy(SET CMP0015 NEW)
 cmake_policy(SET CMP0022 NEW)
 
-project(wlcs VERSION 1.0.0)
+project(wlcs VERSION 1.2.0)
 
 add_definitions(-D_GNU_SOURCE)
 add_definitions(-D_FILE_OFFSET_BITS=64)
@@ -46,6 +46,14 @@
   # GTest's parametrised test macro tweaks this warning
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=gnu-zero-variadic-macro-arguments")
 endif ()
+
+include(CheckCXXSymbolExists)
+list(APPEND CMAKE_REQUIRED_HEADERS ${GTEST_INCLUDE_DIRECTORIES})
+check_cxx_symbol_exists(INSTANTIATE_TEST_SUITE_P "gtest/gtest.h" HAVE_INSTANTIATE_TEST_SUITE_P)
+if (NOT HAVE_INSTANTIATE_TEST_SUITE_P)
+  #GTest conveniently renamed INSTANTIATE_TEST_CASE_P and then deprecated it.
+  add_definitions(-DINSTANTIATE_TEST_SUITE_P=INSTANTIATE_TEST_CASE_P)
+endif()
 
 find_package(Boost)
 find_package(GtestGmock)
@@ -113,6 +121,11 @@
 GENERATE_PROTOCOL(wayland)
 GENERATE_PROTOCOL(xdg-shell-unstable-v6)
 GENERATE_PROTOCOL(xdg-shell)
+GENERATE_PROTOCOL(wlr-layer-shell-unstable-v1)
+GENERATE_PROTOCOL(xdg-output-unstable-v1)
+GENERATE_PROTOCOL(wlr-foreign-toplevel-management-unstable-v1)
+GENERATE_PROTOCOL(pointer-constraints-unstable-v1)
+GENERATE_PROTOCOL(relative-pointer-unstable-v1)
 
 option(WLCS_BUILD_ASAN "Build a test runner with AddressSanitizer annotations" ON)
 option(WLCS_BUILD_TSAN "Build a test runner with ThreadSanitizer annotations" ON)
@@ -125,10 +138,19 @@
   include/wlcs/pointer.h
   include/wlcs/touch.h
   include/helpers.h
+  include/wl_handle.h
   include/in_process_server.h
+  include/pointer_constraints_unstable_v1.h
   include/primary_selection.h
+  include/relative_pointer_unstable_v1.h
   include/xdg_shell_v6.h
   include/xdg_shell_stable.h
+  include/xdg_output_v1.h
+  include/version_specifier.h
+  include/wl_interface_descriptor.h
+  include/layer_shell_v1.h
+  include/surface_builder.h
+  include/input_method.h
 
   src/data_device.cpp
   src/gtk_primary_selection.cpp
@@ -136,17 +158,25 @@
   src/in_process_server.cpp
   src/xdg_shell_v6.cpp
   src/xdg_shell_stable.cpp
+  src/layer_shell_v1.cpp
   src/main.cpp
+  src/pointer_constraints_unstable_v1.cpp
   src/primary_selection.cpp
   src/shared_library.cpp
+  src/relative_pointer_unstable_v1.cpp
   src/xfail_supporting_test_listener.h
   src/xfail_supporting_test_listener.cpp
   src/termcolor.hpp
   src/thread_proxy.h
+  src/xdg_output_v1.cpp
+  src/version_specifier.cpp
+  src/surface_builder.cpp
+  src/input_method.cpp
 
   ${PROTOCOL_SOURCES}
 
   tests/test_bad_buffer.cpp
+  tests/pointer_constraints.cpp
   tests/copy_cut_paste.cpp
   tests/gtk_primary_selection.cpp
   tests/test_surface_events.cpp
@@ -155,12 +185,16 @@
   tests/surface_input_regions.cpp
   tests/frame_submission.cpp
   tests/primary_selection.cpp
+  tests/relative_pointer.cpp
   tests/subsurfaces.cpp
   tests/xdg_surface_v6.cpp
   tests/xdg_toplevel_v6.cpp
   tests/xdg_surface_stable.cpp
   tests/xdg_toplevel_stable.cpp
   tests/xdg_popup.cpp
+  tests/wlr_layer_shell_v1.cpp
+  tests/xdg_output_v1.cpp
+  tests/wlr_foreign_toplevel_management_v1.cpp
   tests/self_test.cpp
 )

=== debian/changelog ===
wlcs (1.2.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * debian/upstream/signing-key.asc:
    + Update upstream maintainer's GPG pubkey.
  * debian/patches:
    + Drop fix-cmake-version.patch. Resolved upstream.
  * debian/copyright:
    + Update auto-generated copyright.in file.
    + Update copyright attributions.
  * debian/control:
    + Bump to DH compat level version 13.
  * debian/control:
    + Bump Standards-Version:to 4.5.0. No changes needed.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 30 Oct 2020 23:42:19 +0100

wlcs (1.1.0+dfsg-7) unstable; urgency=medium

  * debian/rules:
    + Set -DWLCS_BUILD_ASAN=OFF for two more architectures (m68k, sh4).

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 08 Sep 2020 19:00:25 +0200

wlcs (1.1.0+dfsg-6) unstable; urgency=medium

  * debian/control:
    + Add B-D: libffi-dev.
  * debian/rules:
    + Set -DWLCS_BUILD_ASAN=OFF for several more architectures (s390x, alpha,
      hppa, ia64, riscv64 and sparc64).

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 08 Sep 2020 17:17:51 +0200

=== debian/control ===
--- 
+++ 
@@ -1,20 +1,20 @@
 Source: wlcs
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Mir Team <team+mir@tracker.debian.org>
+Maintainer: Debian Mir Team <team+mir@tracker.debian.org>
 Uploaders:
  Christopher James Halse Rogers <raof@ubuntu.com>,
  Mike Gabriel <sunweaver@debian.org>,
 Build-Depends:
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  cmake,
  libboost-dev,
+ libffi-dev,
  libgtest-dev,
  libwayland-dev,
  pkg-config,
  google-mock
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Rules-Requires-Root: no
 Homepage: https://github.com/MirServer/wlcs
 Vcs-Browser: https://salsa.debian.org/mir-server-team/wlcs

## wlcs 1.2.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -21,7 +21,7 @@
 cmake_policy(SET CMP0015 NEW)
 cmake_policy(SET CMP0022 NEW)
 
-project(wlcs VERSION 1.2.0)
+project(wlcs VERSION 1.2.1)
 
 add_definitions(-D_GNU_SOURCE)
 add_definitions(-D_FILE_OFFSET_BITS=64)

=== debian/changelog ===
wlcs (1.2.1-1) unstable; urgency=medium

  * New upstream release.
  * debian/upstream/signing-key.asc:
    + Update pubkey 0xF4A0E7F950F362FA5B719C48D4DB4A9F5D044F1A (RAOF).
  * debian/{watch,rules,copyright}:
    + Don't repack orig tarball anymore. Non-DFSG files have been removed
      from the upstream project.
  * debian/control:
    + Bump Standards-Version: to 4.5.1. No changes needed.
  * debian/copyright:
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 26 Feb 2021 22:03:29 +0100

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
  libwayland-dev,
  pkg-config,
  google-mock
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Rules-Requires-Root: no
 Homepage: https://github.com/MirServer/wlcs
 Vcs-Browser: https://salsa.debian.org/mir-server-team/wlcs

=== debian/rules ===
--- 
+++ 
@@ -24,7 +24,7 @@
   WITH_UBSAN = -DWLCS_BUILD_UBSAN=OFF
 endif
 
-ifneq ($(filter mipsel mips64el riscv64 s390x, $(DEB_HOST_ARCH)),)
+ifneq ($(filter mipsel mips64el s390x alpha hppa ia64 m68k riscv64 sh4 sparc64, $(DEB_HOST_ARCH)),)
   WITH_ASAN = -DWLCS_BUILD_ASAN=OFF
 endif
 
@@ -41,4 +41,4 @@
 	dh $@
 
 get-orig-source:
-	uscan --noconf --force-download --rename --download-current-version --repack --destdir=..
+	uscan --noconf --force-download --rename --download-current-version --destdir=..

=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4

opts="pgpsigurlmangle=s/$/.asc/" \
    https://github.com/MirServer/wlcs/releases/latest .*/wlcs-(\d\S+)\.tar\.xz

## wlcs 1.3.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -21,7 +21,7 @@
 cmake_policy(SET CMP0015 NEW)
 cmake_policy(SET CMP0022 NEW)
 
-project(wlcs VERSION 1.2.1)
+project(wlcs VERSION 1.3.0)
 
 add_definitions(-D_GNU_SOURCE)
 add_definitions(-D_FILE_OFFSET_BITS=64)
@@ -31,9 +31,12 @@
 find_package(PkgConfig)
 #include (Doxygen.cmake)
 
+set(CMAKE_CXX_STANDARD 17)
+set(CMAKE_CXX_EXTENSIONS OFF)
+set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pthread -g -Werror -Wall -pedantic -Wextra -fPIC")
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread -g -std=c++14 -Werror -Wall -fno-strict-aliasing -pedantic -Wnon-virtual-dtor -Wextra -fPIC")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread -g -Werror -Wall -fno-strict-aliasing -pedantic -Wnon-virtual-dtor -Wextra -fPIC")
 if ("${CMAKE_SHARED_LINKER_FLAGS}" MATCHES ".*-fsanitize=.*")
   set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS}")
 else()

=== debian/changelog ===
wlcs (1.3.0-4deepin1) unstable; urgency=medium

  [ Dandan Zhang ]
  * debian/rules:
    + Set -DWLCS_BUILD_ASAN=OFF for LoongArch architecture.

 -- Tianyu Chen <sweetyfish@deepin.org>  Tue, 24 Sep 2024 14:24:02 +0800

wlcs (1.3.0-4deepin0) unstable; urgency=medium

  * No source change upload against GCC 12.

 -- Tianyu Chen <sweetyfish@deepin.org>  Fri, 20 Sep 2024 12:57:58 +0800

wlcs (1.3.0-4) unstable; urgency=medium

  [ Marius Gripsgard ]
  * debian/rules:
    + Fix FTBFS on armel and powerpc due to missing atomic linkage.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 12 Nov 2021 10:16:44 +0100

wlcs (1.3.0-3) unstable; urgency=medium

  [ Marius Gripsgard ]
  * debian/patches:
    + Add 0001-cmake-always-set-GTEST_LIBRARY-if-it-isn-t.patch and
      0002-Fix-build-when-using-GTest-1.11.patch. Fix FTBFS (cmake:
      always set GTEST_LIBRARY if it isn't; fix build when using GTest-1.11).
      (Closes: #998894).

  [ Debian Janitor ]
  * debian/upstream/metadata:
    + Set upstream metadata fields: Repository.
    + Remove obsolete field Name from debian/upstream/metadata
      (already present in machine-readable debian/copyright).

  [ Mike Gabriel ]
  * debian/copyright:
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 10 Nov 2021 17:03:08 +0100

wlcs (1.3.0-2) unstable; urgency=medium

  * Upload to unstable as is.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 13 Sep 2021 21:47:46 +0200

wlcs (1.3.0-1) experimental; urgency=medium

  * New upstream release. Notable changes:
    + Check Cursor movement is not propagating to clients correctly
      when zwp_relative_pointer_manager_v1 is enabled
    + Test that correct input event is used for interactive move
    + Test that layer surfaces are correctly reconfigured
    + Add tests for popup done event
    + Test surfaces get enter/leave events
    + Test version 2 and 3 features of zwlr_layer_shell_v1
  * debian/copyright:
    + Refresh for new upstream

 -- Christopher James Halse Rogers <raof@ubuntu.com>  Thu, 17 Jun 2021 09:38:35 +1000

=== debian/rules ===
--- 
+++ 
@@ -4,6 +4,10 @@
 
 # see FEATURE AREAS in dpkg-buildflags(1)
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+
+ifneq (,$(filter $(DEB_HOST_ARCH), armel mips mipsel powerpc))
+  export DEB_LDFLAGS_MAINT_APPEND = -latomic
+endif
 
 WITH_ASAN  = -DWLCS_BUILD_ASAN=ON
 WITH_UBSAN = -DWLCS_BUILD_UBSAN=ON
@@ -16,15 +20,15 @@
   endif
 endif
 
-ifneq ($(filter armel armhf i386 mipsel mips64el s390x alpha hppa ia64 m68k powerpc riscv64 sh4 sparc64 x32, $(DEB_HOST_ARCH)),)
+ifneq ($(filter armel armhf i386 mipsel mips64el s390x alpha hppa ia64 loong64 m68k powerpc riscv64 sh4 sparc64 x32, $(DEB_HOST_ARCH)),)
   WITH_TSAN = -DWLCS_BUILD_TSAN=OFF
 endif
 
-ifneq ($(filter mipsel mips64el alpha hppa ia64 m68k powerpc riscv64 sh4, $(DEB_HOST_ARCH)),)
+ifneq ($(filter mipsel mips64el alpha hppa ia64 loong64 m68k powerpc riscv64 sh4, $(DEB_HOST_ARCH)),)
   WITH_UBSAN = -DWLCS_BUILD_UBSAN=OFF
 endif
 
-ifneq ($(filter mipsel mips64el s390x alpha hppa ia64 m68k riscv64 sh4 sparc64, $(DEB_HOST_ARCH)),)
+ifneq ($(filter mipsel mips64el s390x alpha hppa ia64 loong64 m68k riscv64 sh4 sparc64, $(DEB_HOST_ARCH)),)
   WITH_ASAN = -DWLCS_BUILD_ASAN=OFF
 endif

## wlcs 1.4.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -21,7 +21,7 @@
 cmake_policy(SET CMP0015 NEW)
 cmake_policy(SET CMP0022 NEW)
 
-project(wlcs VERSION 1.3.0)
+project(wlcs VERSION 1.4.0)
 
 add_definitions(-D_GNU_SOURCE)
 add_definitions(-D_FILE_OFFSET_BITS=64)
@@ -129,6 +129,8 @@
 GENERATE_PROTOCOL(wlr-foreign-toplevel-management-unstable-v1)
 GENERATE_PROTOCOL(pointer-constraints-unstable-v1)
 GENERATE_PROTOCOL(relative-pointer-unstable-v1)
+GENERATE_PROTOCOL(text-input-unstable-v3)
+GENERATE_PROTOCOL(input-method-unstable-v2)
 
 option(WLCS_BUILD_ASAN "Build a test runner with AddressSanitizer annotations" ON)
 option(WLCS_BUILD_TSAN "Build a test runner with ThreadSanitizer annotations" ON)
@@ -199,6 +201,7 @@
   tests/xdg_output_v1.cpp
   tests/wlr_foreign_toplevel_management_v1.cpp
   tests/self_test.cpp
+  tests/text_input_v3_with_input_method_v2.cpp
 )
 
 add_library(test_c_compile OBJECT src/test_c_compile.c)

=== debian/changelog ===
wlcs (1.4.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches:
    + Drop patches 0001 and 0002. Applied upstream.
  * debian/control:
    + Bump Standards-Version: to 4.6.0. No changes needed.
  * debian/copyright:
    + Update auto-generated copyright.in file.
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 04 Apr 2022 23:30:52 +0200

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
  libwayland-dev,
  pkg-config,
  google-mock
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: https://github.com/MirServer/wlcs
 Vcs-Browser: https://salsa.debian.org/mir-server-team/wlcs

## wlcs 1.5.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -21,7 +21,7 @@
 cmake_policy(SET CMP0015 NEW)
 cmake_policy(SET CMP0022 NEW)
 
-project(wlcs VERSION 1.4.0)
+project(wlcs VERSION 1.5.0)
 
 add_definitions(-D_GNU_SOURCE)
 add_definitions(-D_FILE_OFFSET_BITS=64)
@@ -31,7 +31,7 @@
 find_package(PkgConfig)
 #include (Doxygen.cmake)
 
-set(CMAKE_CXX_STANDARD 17)
+set(CMAKE_CXX_STANDARD 20)
 set(CMAKE_CXX_EXTENSIONS OFF)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
@@ -131,55 +131,13 @@
 GENERATE_PROTOCOL(relative-pointer-unstable-v1)
 GENERATE_PROTOCOL(text-input-unstable-v3)
 GENERATE_PROTOCOL(input-method-unstable-v2)
+GENERATE_PROTOCOL(wlr-virtual-pointer-unstable-v1)
 
 option(WLCS_BUILD_ASAN "Build a test runner with AddressSanitizer annotations" ON)
 option(WLCS_BUILD_TSAN "Build a test runner with ThreadSanitizer annotations" ON)
 option(WLCS_BUILD_UBSAN "Build a test runner with UndefinedBehaviourSanitizer annotations" ON)
 
-set(
-  WLCS_SOURCES
-
-  include/wlcs/display_server.h
-  include/wlcs/pointer.h
-  include/wlcs/touch.h
-  include/helpers.h
-  include/wl_handle.h
-  include/in_process_server.h
-  include/pointer_constraints_unstable_v1.h
-  include/primary_selection.h
-  include/relative_pointer_unstable_v1.h
-  include/xdg_shell_v6.h
-  include/xdg_shell_stable.h
-  include/xdg_output_v1.h
-  include/version_specifier.h
-  include/wl_interface_descriptor.h
-  include/layer_shell_v1.h
-  include/surface_builder.h
-  include/input_method.h
-
-  src/data_device.cpp
-  src/gtk_primary_selection.cpp
-  src/helpers.cpp
-  src/in_process_server.cpp
-  src/xdg_shell_v6.cpp
-  src/xdg_shell_stable.cpp
-  src/layer_shell_v1.cpp
-  src/main.cpp
-  src/pointer_constraints_unstable_v1.cpp
-  src/primary_selection.cpp
-  src/shared_library.cpp
-  src/relative_pointer_unstable_v1.cpp
-  src/xfail_supporting_test_listener.h
-  src/xfail_supporting_test_listener.cpp
-  src/termcolor.hpp
-  src/thread_proxy.h
-  src/xdg_output_v1.cpp
-  src/version_specifier.cpp
-  src/surface_builder.cpp
-  src/input_method.cpp
-
-  ${PROTOCOL_SOURCES}
-
+set(WLCS_TESTS
   tests/test_bad_buffer.cpp
   tests/pointer_constraints.cpp
   tests/copy_cut_paste.cpp
@@ -202,7 +160,61 @@
   tests/wlr_foreign_toplevel_management_v1.cpp
   tests/self_test.cpp
   tests/text_input_v3_with_input_method_v2.cpp
-)
+  tests/wlr_virtual_pointer_v1.cpp
+)
+
+set(
+  WLCS_SOURCES
+
+  include/wlcs/display_server.h
+  include/wlcs/pointer.h
+  include/wlcs/touch.h
+  include/helpers.h
+  include/wl_handle.h
+  include/in_process_server.h
+  include/pointer_constraints_unstable_v1.h
+  include/primary_selection.h
+  include/relative_pointer_unstable_v1.h
+  include/xdg_shell_v6.h
+  include/xdg_shell_stable.h
+  include/xdg_output_v1.h
+  include/version_specifier.h
+  include/wl_interface_descriptor.h
+  include/layer_shell_v1.h
+  include/surface_builder.h
+  include/input_method.h
+
+  src/data_device.cpp
+  src/gtk_primary_selection.cpp
+  src/helpers.cpp
+  src/in_process_server.cpp
+  src/xdg_shell_v6.cpp
+  src/xdg_shell_stable.cpp
+  src/layer_shell_v1.cpp
+  src/main.cpp
+  src/pointer_constraints_unstable_v1.cpp
+  src/primary_selection.cpp
+  src/shared_library.cpp
+  src/relative_pointer_unstable_v1.cpp
+  src/xfail_supporting_test_listener.h
+  src/xfail_supporting_test_listener.cpp
+  src/termcolor.hpp
+  src/thread_proxy.h
+  src/xdg_output_v1.cpp
+  src/version_specifier.cpp
+  src/surface_builder.cpp
+  src/input_method.cpp
+
+  ${PROTOCOL_SOURCES}
+  ${WLCS_TESTS}
+)
+
+# g++ 9.4 (on 20.04) hates the MOCK_METHOD macro
+if (CMAKE_COMPILER_IS_GNUCXX AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 10)
+  # Neither gnu-zero-variadic-macro-arguments nor variadic-macro help,
+  # we just have to drop pedantic...
+  set_property(SOURCE ${WLCS_TESTS} PROPERTY COMPILE_OPTIONS -Wno-pedantic)
+endif()
 
 add_library(test_c_compile OBJECT src/test_c_compile.c)
 
@@ -266,7 +278,7 @@
 
 install(
   DIRECTORY include/wlcs
-  DESTINATION ${CMAKE_INSTALL_PREFIX}/include/
+  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
 )
 
 configure_file(

=== debian/changelog ===
wlcs (1.5.0-1ubuntu1) lunar; urgency=medium

  * debian/rules:
    + Drop optimisation level to -O2 on ppc64el to work around
      https://gcc.gnu.org/bugzilla/show_bug.cgi?id=105329.
      Fixes FTBFS on ppc64el.
  * debian/gbp.conf
    + Point at Ubuntu branch

 -- Christopher James Halse Rogers <raof@ubuntu.com>  Wed, 22 Feb 2023 18:00:18 +1100

wlcs (1.5.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/watch:
    + Obtain orig tarball from Git tag.
    + No pgpsigurlmangling anymore.
  * debian/upstream/signing-key.asc:
    + Drop for now. Release downloads are broken on Github these days.
  * debian/copyright:
    + Update auto-generated copyright.in file.
    + Update copyright attributions.
  * debian/control:
    + Bump Standards-Version: to 4.6.2. No changes needed.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 29 Jan 2023 20:30:05 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: wlcs
 Section: devel
 Priority: optional
-Maintainer: Debian Mir Team <team+mir@tracker.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Mir Team <team+mir@tracker.debian.org>
 Uploaders:
  Christopher James Halse Rogers <raof@ubuntu.com>,
  Mike Gabriel <sunweaver@debian.org>,
@@ -14,7 +15,7 @@
  libwayland-dev,
  pkg-config,
  google-mock
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://github.com/MirServer/wlcs
 Vcs-Browser: https://salsa.debian.org/mir-server-team/wlcs

=== debian/rules ===
--- 
+++ 
@@ -20,15 +20,15 @@
   endif
 endif
 
-ifneq ($(filter armel armhf i386 mipsel mips64el s390x alpha hppa ia64 loong64 m68k powerpc riscv64 sh4 sparc64 x32, $(DEB_HOST_ARCH)),)
+ifneq ($(filter armel armhf i386 mipsel mips64el s390x alpha hppa ia64 m68k powerpc riscv64 sh4 sparc64 x32, $(DEB_HOST_ARCH)),)
   WITH_TSAN = -DWLCS_BUILD_TSAN=OFF
 endif
 
-ifneq ($(filter mipsel mips64el alpha hppa ia64 loong64 m68k powerpc riscv64 sh4, $(DEB_HOST_ARCH)),)
+ifneq ($(filter mipsel mips64el alpha hppa ia64 m68k powerpc riscv64 sh4, $(DEB_HOST_ARCH)),)
   WITH_UBSAN = -DWLCS_BUILD_UBSAN=OFF
 endif
 
-ifneq ($(filter mipsel mips64el s390x alpha hppa ia64 loong64 m68k riscv64 sh4 sparc64, $(DEB_HOST_ARCH)),)
+ifneq ($(filter mipsel mips64el s390x alpha hppa ia64 m68k riscv64 sh4 sparc64, $(DEB_HOST_ARCH)),)
   WITH_ASAN = -DWLCS_BUILD_ASAN=OFF
 endif
 
@@ -38,6 +38,16 @@
   $(WITH_TSAN) \
   -DCMAKE_INSTALL_LIBEXECDIR="lib/${DEB_HOST_MULTIARCH}"
 
+# https://gcc.gnu.org/bugzilla/show_bug.cgi?id=105329
+ifeq ($(DEB_HOST_ARCH), ppc64el)
+  ifneq ($(shell gcc --version | grep '12.[[:digit:]]\+.[[:digit:]]\+$$'),)
+    export DEB_CFLAGS_MAINT_APPEND = -O2
+    export DEB_CXXFLAGS_MAINT_APPEND = -O2
+    export DEB_FCFLAGS_MAINT_APPEND = -O2
+    export DEB_FFLAGS_MAINT_APPEND = -O2
+  endif
+endif
+
 override_dh_auto_configure:
 	dh_auto_configure -- $(COMMON_CONFIGURE_OPTIONS)

## wlcs 1.6.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -281,6 +281,10 @@
   DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
 )
 
+include(JoinPaths)
+join_paths(PKGCONFIG_BINDIR "\${prefix}" "${CMAKE_INSTALL_BINDIR}")
+join_paths(PKGCONFIG_LIBEXECDIR "\${prefix}" "${CMAKE_INSTALL_LIBEXECDIR}")
+join_paths(PKGCONFIG_INCLUDEDIR "\${prefix}" "${CMAKE_INSTALL_INCLUDEDIR}")
 configure_file(
   wlcs.pc.in
   ${CMAKE_CURRENT_BINARY_DIR}/wlcs.pc

=== debian/changelog ===
wlcs (1.6.0-1ubuntu1) mantic; urgency=medium

  * Sync from Debian unstable
  * New Ubuntu changes:
    - debian/patches/0001-fix-g++-13-FTBFS.patch:
      + Cherry-pick upstream commit fixing the build on GCC 13

 -- Christopher James Halse Rogers <raof@ubuntu.com>  Mon, 14 Aug 2023 17:58:57 +1000

wlcs (1.6.0-1) unstable; urgency=medium

  * New upstream version 1.6.0
  * debian/control: Add ubports team to uploaders
  * debian/control: Add myself to uploaders
  * debian/copyright: Refresh copyright to match upstream release

 -- Marius Gripsgard <mariogrip@debian.org>  Thu, 10 Aug 2023 23:35:06 +0200

=== debian/control ===
--- 
+++ 
@@ -4,8 +4,10 @@
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Debian Mir Team <team+mir@tracker.debian.org>
 Uploaders:
+ Debian UBports Team <team+ubports@tracker.debian.org>,
  Christopher James Halse Rogers <raof@ubuntu.com>,
  Mike Gabriel <sunweaver@debian.org>,
+ Marius Gripsgard <mariogrip@debian.org>,
 Build-Depends:
  debhelper-compat (= 13),
  cmake,

## wlcs 1.6.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -21,7 +21,7 @@
 cmake_policy(SET CMP0015 NEW)
 cmake_policy(SET CMP0022 NEW)
 
-project(wlcs VERSION 1.5.0)
+project(wlcs VERSION 1.6.1)
 
 add_definitions(-D_GNU_SOURCE)
 add_definitions(-D_FILE_OFFSET_BITS=64)
@@ -129,7 +129,9 @@
 GENERATE_PROTOCOL(wlr-foreign-toplevel-management-unstable-v1)
 GENERATE_PROTOCOL(pointer-constraints-unstable-v1)
 GENERATE_PROTOCOL(relative-pointer-unstable-v1)
+GENERATE_PROTOCOL(text-input-unstable-v2)
 GENERATE_PROTOCOL(text-input-unstable-v3)
+GENERATE_PROTOCOL(input-method-unstable-v1)
 GENERATE_PROTOCOL(input-method-unstable-v2)
 GENERATE_PROTOCOL(wlr-virtual-pointer-unstable-v1)
 
@@ -161,6 +163,7 @@
   tests/self_test.cpp
   tests/text_input_v3_with_input_method_v2.cpp
   tests/wlr_virtual_pointer_v1.cpp
+  tests/text_input_v2_with_input_method_v1.cpp
 )
 
 set(
@@ -247,7 +250,12 @@
 
 if (WLCS_BUILD_UBSAN)
   add_executable(wlcs.ubsan ${WLCS_SOURCES})
-  target_compile_options(wlcs.ubsan PUBLIC -fsanitize=undefined)
+  # g++ 13 doesn't like some initialization
+  if (CMAKE_COMPILER_IS_GNUCXX AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 13)
+    target_compile_options(wlcs.ubsan PUBLIC -fsanitize=undefined)
+  else()
+    target_compile_options(wlcs.ubsan PUBLIC -fsanitize=undefined -O0)
+  endif()
   set_target_properties(
     wlcs.ubsan
     PROPERTIES

=== debian/changelog ===
wlcs (1.6.1-2ubuntu1) plucky; urgency=medium

  * Set -Wno-error=maybe-uninitialized to fix the FTBFS.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Tue, 04 Mar 2025 20:29:46 -0600

wlcs (1.6.1-2) unstable; urgency=medium

  [ Mike Gabriel ]
  * debian/patches:
    + Add 0001_remove-I-don-t-think-that-algorithm-does-what-you-th.patch.
      Fixes FTBFS with GCC-14. (Closes: #1075640).
  * debian/control:
    + Switch from pkg-config to pkgconf in B-D. Thanks, lintian.

  [ Marius Gripsgard ]
  * debian/rules:
    + Set -DWLCS_BUILD_ASAN=OFF for LoongArch architecture. (Closes: #1051830).

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 22 Sep 2024 13:53:43 +0200

wlcs (1.6.1-1) unstable; urgency=medium

  * New upstream version 1.6.1
  * d/copyright: Update to match upstream release

 -- Marius Gripsgard <mariogrip@debian.org>  Sun, 29 Oct 2023 15:53:23 +0100

=== debian/control ===
--- 
+++ 
@@ -15,7 +15,7 @@
  libffi-dev,
  libgtest-dev,
  libwayland-dev,
- pkg-config,
+ pkgconf,
  google-mock
 Standards-Version: 4.6.2
 Rules-Requires-Root: no

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CXXFLAGS_MAINT_APPEND := -Wno-error=maybe-uninitialized

ifneq (,$(filter $(DEB_HOST_ARCH), armel mips mipsel powerpc))
  export DEB_LDFLAGS_MAINT_APPEND = -latomic
endif

WITH_ASAN  = -DWLCS_BUILD_ASAN=ON
WITH_UBSAN = -DWLCS_BUILD_UBSAN=ON
WITH_TSAN  = -DWLCS_BUILD_TSAN=ON

ifeq ($(DEB_DISTRIBUTION),xenial)
  ifneq ($(filter arm64 ppc64el, $(DEB_HOST_ARCH)),)
    # arm64 on 16.04 does not have tsan
    WITH_TSAN = -DWLCS_BUILD_TSAN=OFF
  endif
endif

ifneq ($(filter armel armhf i386 mipsel mips64el s390x alpha hppa ia64 loong64 m68k powerpc riscv64 sh4 sparc64 x32, $(DEB_HOST_ARCH)),)
  WITH_TSAN = -DWLCS_BUILD_TSAN=OFF
endif

ifneq ($(filter mipsel mips64el alpha hppa ia64 loong64 m68k powerpc riscv64 sh4, $(DEB_HOST_ARCH)),)
  WITH_UBSAN = -DWLCS_BUILD_UBSAN=OFF
endif

ifneq ($(filter mipsel mips64el s390x alpha hppa loong64 ia64 m68k riscv64 sh4 sparc64, $(DEB_HOST_ARCH)),)
  WITH_ASAN = -DWLCS_BUILD_ASAN=OFF
endif

COMMON_CONFIGURE_OPTIONS =\
  $(WITH_ASAN) \
  $(WITH_UBSAN) \
  $(WITH_TSAN) \
  -DCMAKE_INSTALL_LIBEXECDIR="lib/${DEB_HOST_MULTIARCH}"

override_dh_auto_configure:
	dh_auto_configure -- $(COMMON_CONFIGURE_OPTIONS)

%:
	dh $@

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..

## wlcs 1.7.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -21,7 +21,7 @@
 cmake_policy(SET CMP0015 NEW)
 cmake_policy(SET CMP0022 NEW)
 
-project(wlcs VERSION 1.6.1)
+project(wlcs VERSION 1.7.0)
 
 add_definitions(-D_GNU_SOURCE)
 add_definitions(-D_FILE_OFFSET_BITS=64)
@@ -250,12 +250,7 @@
 
 if (WLCS_BUILD_UBSAN)
   add_executable(wlcs.ubsan ${WLCS_SOURCES})
-  # g++ 13 doesn't like some initialization
-  if (CMAKE_COMPILER_IS_GNUCXX AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 13)
-    target_compile_options(wlcs.ubsan PUBLIC -fsanitize=undefined)
-  else()
-    target_compile_options(wlcs.ubsan PUBLIC -fsanitize=undefined -O0)
-  endif()
+  target_compile_options(wlcs.ubsan PUBLIC -fsanitize=undefined)
   set_target_properties(
     wlcs.ubsan
     PROPERTIES

=== debian/changelog ===
wlcs (1.7.0-1ubuntu1) questing; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Set -Wno-error=maybe-uninitialized to fix the FTBFS.

 -- Rik Mills <rikmills@kde.org>  Thu, 22 May 2025 08:09:10 +0100

wlcs (1.7.0-1) unstable; urgency=medium

  * Re-upload to unstable.
  * debian/control:
    + Bump Standards-Version: to 4.7.2. No changes needed.
  * debian/copyright:
    + Update copyright attributions for debian/.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 16 Mar 2025 18:12:12 +0100

wlcs (1.7.0-1~exp1) experimental; urgency=medium

  [ Marius Gripsgard ]
  * New upstream release 1.7.0

  [ Dandan Zhang ]
  * debian/rules:
    + Set -DWLCS_BUILD_ASAN=OFF for LoongArch architecture. (closes: #1051830)

 -- Marius Gripsgard <mariogrip@debian.org>  Sat, 03 Feb 2024 00:02:22 +0100

=== debian/control ===
--- 
+++ 
@@ -17,7 +17,7 @@
  libwayland-dev,
  pkgconf,
  google-mock
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://github.com/MirServer/wlcs
 Vcs-Browser: https://salsa.debian.org/mir-server-team/wlcs
